###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on the original La Fonera Firmware version 0.7.1r2
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /etc/functions.sh

config_load router
config_get mode mode mode

libdir=/usr/lib/webif
wwwdir=/www
cgidir=/www/cgi-bin/webif
rootdir=/cgi-bin/webif
indexpage=index.sh

# workarounds for stupid busybox slowness on [ ]
empty() {
	case "$1" in
		"") return 0 ;;
		*) return 255 ;;
	esac
}
equal() {
	case "$1" in
		"$2") return 0 ;;
		*) return 255 ;;
	esac
}
neq() {
	case "$1" in
		"$2") return 255 ;;
		*) return 0 ;;
	esac
}
# very crazy, but also very fast :-)
exists() {
	( < $1 ) 2>&-
}

categories() {
	grep '##WEBIF:' $cgidir/.categories $cgidir/*.sh 2>/dev/null | \
		awk -v "selected=$1" \
			${HEADER_PLAIN:+-v plain=1} \
			-v "rootdir=$rootdir" \
			-v "indexpage=$indexpage" \
			-v "path=$PATH_INFO" \
			-f /usr/lib/webif/categories.awk -
}

header() {
	local title="$1"

	empty "$ERROR" && {
		_saved_title="${SAVED:+: @TR<<Settings saved>>}"
	} || {
		FORM_submit="";
		ERROR="<h3>$ERROR</h3><br /><br />"
		_saved_title=": @TR<<Error>>"
	}

case "$mode" in

	1) cat <<EOF
content-type: text/html
pragma: no-cache

<?xml version="1.0" encoding="@TR<<Encoding|ISO-8859-1>>"?>
<html>
<head>
	<title>Fonera Webinterface - enhanced by FreeWLAN.info</title>
	<link rel="stylesheet" href="/style.css" type="text/css" />
	<meta http-equiv="Content-Type" content="text/html; charset=@TR<<Encoding|ISO-8859-1>>" />
	<meta name="author" content="FON Wireless" />
</head>
<body>
	<script type="text/javascript" src="/webif.js"></script>
	<script type="text/javascript">
	function submitform(){
		document.myform.submit();
	}
	</script>

	<center>
	<table width="90%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td background="/images/table/left.gif" valign="top"><img src="/images/table/top-left.gif" width="38" height="82"></td>
			<td rowspan="2" valign="top" width="177">
			  <div id="sidebar">
				<!--NAVIGATION-->
				<table width="100%" border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td rowspan="2" width="167" height="175"><a href="http://www.freewlan.info" target="_blank"><img src="/images/table/logo.gif" border="0"></a>
							<!--NAVIGATION BUTTONS-->
							<table>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/status.sh">@TR<<Status>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/mode.sh">@TR<<Router Mode>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/statistics.sh">@TR<<Statistics>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/public.sh">@TR<<Public WiFi>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/private.sh">@TR<<Private WiFi>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/password.sh">@TR<<Password>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/language.sh">@TR<<Language>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/connection.sh">@TR<<Advanced>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								$ADV_SUBMENU
							</table>
							<br />
							<br />
						</td>

						<td style="background: transparent url(/images/table/top.gif) repeat-x;" width="10"></td>

					</tr>
					<tr>
						<td background="/images/table/sidebar.gif"></td>
					</tr>
				</table>
			  </div>
			</td>
			<td style="background: transparent url(/images/table/top.gif) repeat-x;" colspan="2" height="82">
				<!--BEGIN MENU CODE-->
				<table width="100%">
					<tr>
						<td><h1><br />@TR<<$title>>$_saved_title</h1></td>
						<td align="right"></td>
					</tr>
				</table>
				<!--END MENU CODE-->
			</td>
			<td  background="/images/table/right.gif" valign="top"><img src="/images/table/top-right.gif" width="38" height="82"></td>
		</tr>
		<tr>
			<td background="/images/table/left.gif" width="38"> </td>
			<td colspan="2" valign="top" style="background: transparent url(/images/Fonera.gif); background-position: 100% 100%; background-repeat: no-repeat;">
				<form method="post" action="$SCRIPT_NAME" enctype="multipart/form-data">
				<br />
				<br />
				$ERROR
EOF
;;

2) cat <<EOF
content-type: text/html
pragma: no-cache

<?xml version="1.0" encoding="@TR<<Encoding|ISO-8859-1>>"?>
<html>
<head>
	<title>Fonera Webinterface - enhanced by freewlan.info</title>
	<link rel="stylesheet" href="/style.css" type="text/css" />
	<meta http-equiv="Content-Type" content="text/html; charset=@TR<<Encoding|ISO-8859-1>>" />
	<meta name="author" content="FON Wireless" />
</head>
<body>
	<script type="text/javascript" src="/webif.js"></script>
	<script type="text/javascript">
	function submitform(){
		document.myform.submit();
	}
	</script>

	<center>
	<table width="90%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td background="/images/table/left.gif" valign="top"><img src="/images/table/top-left.gif" width="38" height="82"></td>
			<td rowspan="2" valign="top" width="177">
			  <div id="sidebar">
				<!--NAVIGATION-->
				<table width="100%" border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td rowspan="2" width="167" height="175"><img src="/images/table/logo.gif">
							<!--NAVIGATION BUTTONS-->
							<table>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/status.sh">@TR<<Status>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/mode.sh">@TR<<Router mode>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/statistics.sh">@TR<<Statistics>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/password.sh">@TR<<Password>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/language.sh">@TR<<Language>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
										<div class="btnleft"></div>
										<div class="btncenter">
											<a href="/cgi-bin/webif/upgrade.sh">@TR<<Advanced>></a>
										</div>
										<div class="btnright"></div>
									</div>
								</td></tr>
								$ADV_SUBMENU
							</table>
							<br />
							<br />
						</td>

						<td style="background: transparent url(/images/table/top.gif) repeat-x;" width="10"></td>

					</tr>
					<tr>
						<td background="/images/table/sidebar.gif"></td>
					</tr>
				</table>
			  </div>
			</td>
			<td style="background: transparent url(/images/table/top.gif) repeat-x;" colspan="2" height="82">
				<!--BEGIN MENU CODE-->
				<table width="100%">
					<tr>
						<td><h1><br />@TR<<$title>>$_saved_title</h1></td>
						<td align="right"></td>
					</tr>
				</table>
				<!--END MENU CODE-->
			</td>
			<td  background="/images/table/right.gif" valign="top"><img src="/images/table/top-right.gif" width="38" height="82"></td>
		</tr>
		<tr>
			<td background="/images/table/left.gif" width="38"> </td>
			<td colspan="2" valign="top" style="background: transparent url(/images/Fonera.gif); background-position: 100% 100%; background-repeat: no-repeat;">
				<form method="post" action="$SCRIPT_NAME" enctype="multipart/form-data">
				<br />
				<br />
				$ERROR
EOF
;;
esac
}

help_header() {
	local title="$1"

cat <<EOF
content-type: text/html
pragma: no-cache

<?xml version="1.0" encoding="@TR<<Encoding|ISO-8859-1>>"?>
<html>
<head>
	<title>Fonera Webinterface - enhanced by FreeWLAN.info</title>
	<link rel="stylesheet" href="/style.css" type="text/css" />
	<meta http-equiv="Content-Type" content="text/html; charset=@TR<<Encoding|ISO-8859-1>>" />
	<meta name="author" content="FON Wireless" />
</head>
<body>
<center>
<div style="width: 95%; font-size: 10pt; text-align: left;">
EOF
}

help_footer() {
	cat <<EOF
	<br />
	<br />
	<center><a href="javascript:self.close()" style="font-size:10pt">@TR<<Close>></a></center>
	</div>
	</center>
</body>
</html>
EOF
}

footer() {
	cat <<EOF
				<br />
				<br />
				</form>
			</td>
			<td background="/images/table/right.gif" width="38"></td>
		</tr>
		<tr>
			<td><img src="/images/table/bottom-left.gif" width="38" height="39"></td>
			<td background="/images/table/bottom.gif" height="39" colspan="3" align="right" style="vertical-align: top; font-size: 8pt; padding-top: 5px"><a href="http://www.freewlan.info">freewlan.info</a></td>
			<td><img src="/images/table/bottom-right.gif" width="38" height="39"></td>
		</tr>
	</table>
	<br />
	</center>
</body>
</html>
EOF
}

display_form() {
	awk -F'|' -f /usr/lib/webif/form.awk
}

load_settings() {
	config_load "$1"
	exists /tmp/.webif/config-$1 && . /tmp/.webif/config-$1
}

validate() {
	eval "$(awk -f /usr/lib/webif/validate.awk)"
}

save_setting() {
	mkdir -p /tmp/.webif
	cat >> /tmp/.webif/config-$1 <<EOF
config update "$2"
	option "$3" "$4"
EOF
}

get_default() {
	eval "FORM_$1=\"\${FORM_$1:-\${CONFIG_${2}_${3}}}\""
}

commit_settings() {(
	reset_cb
	option_cb() {
		# FixME: ';' cannot be used in any config values
		updatestr="${updatestr:+$updatestr;}$CONFIG_SECTION.$1=$2"
	}

	for cfg in /tmp/.webif/config-*; do
		exists $cfg || continue
		export cfgfile="${cfg##*config-}"
		export updatestr=
		. $cfg

		lock /tmp/.webif/update-$cfgfile
		awk \
			-v cfgfile="/etc/config/$cfgfile" \
			-v updatestr="$updatestr" \
			-f /usr/lib/webif/uci-update.awk \
			-f - > /etc/config/$cfgfile.new <<EOF
BEGIN {
	cfg = read_file(cfgfile)
	print update_config(cfg, updatestr)
}
EOF
		equal "$?" 0 && {
			mv /etc/config/$cfgfile.new /etc/config/$cfgfile
			rm -f /tmp/.webif/config-$cfgfile
		}
		lock -u /tmp/.webif/update-$cfgfile
	done
)}
